int W = 400;
int numStars = 100;
color sky = color(25,25,112);

// We will write to a hypothetical 300x200 canvas,
// but scale appropriately for other sizes
float scale = W/300.0;
size(W,int(200*scale));
background(sky);


// insert stars here...
stroke(255);
strokeWeight(1*scale);
for (int j=0; j<numStars; j++) {
  point(random(300*scale), random(110*scale));
}

// moon
noStroke();
fill(180,200,220);
ellipse(scale*250, scale*50, scale*30, scale*30);
fill(sky);
ellipse(scale*260, scale*50, scale*30, scale*30); // mask to leave cresent shape

// grass
fill(0,255,0);
stroke(0,255,0);
strokeWeight(1);
rect(0, scale*120, scale*300, scale*80);

// tree
stroke(0);
fill(0,100,0);
triangle(scale*50, scale*80,
         scale*30, scale*140,
         scale*70, scale*140);

// house facade
fill(255);
rect(scale*110, scale*100, scale*60, scale*60);

// house roof
fill(127);
quad(scale*105, scale*105, scale*175, scale*105,
     scale*170, scale*85, scale*110, scale*85);

// chimney
stroke(255,0,0);
fill(255,0,0);
rect(scale*148, scale*72, scale*15, scale*28);

// window
fill(0);
strokeWeight(2*scale);
rect(scale*123, scale*110, scale*15, scale*20);


save("houseStars.jpg");
