int numSteps = 10;
int stepSize = 40;

int N = numSteps * stepSize;
size(N, N);
background(255);

fill(200);  // light gray

for (int level = 0; level < N/stepSize; level += 1) {
  int start = (numSteps-level-1)*stepSize/2;
  for (int block = 0; block < 1+level; block++) {
    rect(start + block*stepSize, level*stepSize, stepSize, stepSize);
  }
}

save("pyramidNested.jpg");
